# Copyright 2016-2021 Swiss National Supercomputing Centre (CSCS/ETH Zurich)
# ReFrame Project Developers. See the top-level LICENSE file for details.
#
# SPDX-License-Identifier: BSD-3-Clause

# Nicked from original CSCS checks tests

# pylint: disable=C0301
"""
Sample numpy operations
----------------------------

Context
~~~~~~~~~~~~~~~~~~~~~~~~

This test has basic numpy matrix operations for a size of 4096. The
`source code <https://gitlab.com/ska-telescope/sdp/ska-sdp-benchmark-tests/-/blob/main/apps/level0/cpu/python/src/numpy_ops.py>`__
can be found in the repository. The size of the test matrices can be changed within the source code.
There are five different operations supported in the test namely:

- Matrix multiplication
- SVD
- Cholesky decomposition
- Eigen decomposition
- Matrix invert

Test parameterisation
~~~~~~~~~~~~~~~~~~~~~~~~

Currently, the test supports only one type of parameterisation in terms of number of threads.
Number of threads can be varied from 1 to maximum number of cores available on the System Under
Test (SUT).

Usage
~~~~~~~~~~~~~~~~~~~~~~~~

The test can be run using following commands.

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level0/cpu/python/reframe_numpy.py --run --performance-report


But first let's see the tests generated by ReFrame using ``--list`` command as follows:

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level0/cpu/python/reframe_numpy.py --list

If we want to run the run with 4 threads, we can use ``--tags`` CLI option to do so.

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level0/cpu/python/reframe_numpy.py --tag 4$ --run --performance-report

Test class documentation
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
"""
# pylint: enable=C0301

import reframe as rfm
import reframe.utility.sanity as sn  # pylint: disable=import-error
from modules.reframe_extras import CondaSetupTest
from modules.base_class import RunOnlyBenchmarkBase
from reframe.core.backends import getlauncher  # pylint: disable=import-error
import reframe.utility.osext as osext  # pylint: disable=import-error

from modules.utils import filter_systems_by_env, emit_conda_activate_cmds
from modules.utils import emit_conda_env_cmds
from reframe.core.builtins import fixture, performance_function, run_after, run_before
import modules.conda_env_manager as cem

ENV_NAME = "rfm_NumpyTest"

@rfm.simple_test
class NumpyTest(RunOnlyBenchmarkBase):
    """Numpy operations benchmark tests"""

    descr = 'Test a few typical numpy operations'

    # install the python packages as a ReFrame fixture
    src_setup = fixture(CondaSetupTest, scope="environment", variables={
        'env_name': ENV_NAME,
        'conda_packages': ['numpy']
    })

    def __init__(self):
        super().__init__()
        self.valid_prog_environs = [
            'numpy',
        ]
        self.valid_systems = filter_systems_by_env(self.valid_prog_environs)
        self.sourcepath = 'numpy_ops.py'
        self.maintainers = [
            'Mahendra Paipuri (mahendra.paipuri@inria.fr)',
            'Manuel Stutz (manuel.stutz@fhnw.ch)'
        ]
        self.time_limit = '0d1h00m0s'
        self.num_nodes = 1
        self.env_manager = cem.CondaEnvManager(ENV_NAME)

    @run_after('setup')
    def set_git_commit_tag(self):
        """Fetch git commit hash"""
        git_ref = osext.git_repo_hash(short=False, wd=self.prefix)
        self.tags |= {f'git={git_ref}'}

    @run_after('setup')
    def set_num_nodes(self):
        """Set number of nodes"""
        self.num_nodes = 1
        if self.current_partition.scheduler.registered_name == 'oar':
            self.num_tasks_per_node = \
                (self.current_partition.processor.num_cpus
                 // self.current_partition.processor.num_cpus_per_core)
        else:
            self.num_tasks_per_node = self.current_partition.processor.num_cpus
        self.num_tasks = self.num_nodes * self.num_tasks_per_node
        self.tags |= {
            'num_threads={}'.format(self.current_partition.processor.num_cpus),
        }

    @run_after('setup')
    def set_num_threads(self):
        """Set number of OpenMP threads"""
        self.env_vars = {
            'OMP_NUM_THREADS': str(self.current_partition.processor.num_cpus),
        }

    @run_after('setup')
    def set_launcher(self):
        """Set launcher to local"""
        self.job.launcher = getlauncher('local')()
        
    @run_after('setup')
    def emit_conda_cmds(self):
        """Emit conda env related commands in the job script"""
        self.prerun_cmds = self.env_manager.emit_conda_activate_cmds().split(';')

    @run_after('setup')
    def set_executable(self):
        """Set executable and its options"""
        self.executable = 'python3'
        self.executable_opts = ['numpy_ops.py']

    @run_before('sanity')
    def set_sanity_patterns(self):
        """Set sanity patterns"""
        self.sanity_patterns = sn.assert_found(r'Numpy version:\s+\S+', self.stdout)

    @performance_function('s')
    def extract_dot_time(self):
        """Performance extraction function for extracting time taken for dot product"""
        return sn.extractsingle(
            r'^Dotted two 4096x4096 matrices in\s+(?P<dot>\S+)\s+s', self.stdout, 'dot', float
        )

    @performance_function('s')
    def extract_svd_time(self):
        """Performance extraction function for extracting time taken for SVD"""
        return sn.extractsingle(
            r'^SVD of a 2048x1024 matrix in\s+(?P<svd>\S+)\s+s', self.stdout, 'svd', float
        )

    @performance_function('s')
    def extract_cholesky_time(self):
        """Performance extraction function for extracting time taken for Cholesky decomposition"""
        return sn.extractsingle(
            r'^Cholesky decomposition of a 2048x2048 matrix in\s+(?P<cholesky>\S+)\s+s',
            self.stdout, 'cholesky', float
        )

    @performance_function('s')
    def extract_eigendec_time(self):
        """Performance extraction function for extracting time taken for Eigen decomposition"""
        return sn.extractsingle(
            r'^Eigendecomposition of a 2048x2048 matrix in\s+(?P<eigendec>\S+)\s+s',
            self.stdout, 'eigendec', float
        )

    @performance_function('s')
    def extract_invert_time(self):
        """Performance extraction function for extracting time taken for matrix inversion"""
        return sn.extractsingle(
            r'^Inversion of a 2048x2048 matrix in\s+(?P<inv>\S+)\s+s', self.stdout, 'inv', float
        )

    @run_before('performance')
    def set_perf_patterns(self):
        """Set performance variables"""
        self.perf_variables = {
            'dot time': self.extract_dot_time(),
            'svd time': self.extract_svd_time(),
            'cholesky time': self.extract_cholesky_time(),
            'eigendec time': self.extract_eigendec_time(),
            'inv time': self.extract_invert_time()
        }

    @run_before('performance')
    def set_reference_values(self):
        """Set reference perf values"""
        self.reference = {
            '*': {
                '*': (None, None, None, 's'),
            },
        }
